/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   main.c                                             :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/16 18:58:41 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/16 18:58:44 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"
#include <time.h>

void drawcircle(t_pnt pnt, float radius, t_fractol *fr)
{
	int x = (int)radius;
	int y = 0;
	int err = 0;

	while (x >= y)
	{
		put_pixel_to_image(pnt.x + x, pnt.y + y, &pnt.color, fr);
		put_pixel_to_image(pnt.x + y, pnt.y + x, &pnt.color, fr);
		put_pixel_to_image(pnt.x - y, pnt.y + x, &pnt.color, fr);
		put_pixel_to_image(pnt.x - x, pnt.y + y, &pnt.color, fr);
		put_pixel_to_image(pnt.x - x, pnt.y - y, &pnt.color, fr);
		put_pixel_to_image(pnt.x - y, pnt.y - x, &pnt.color, fr);
		put_pixel_to_image(pnt.x + y, pnt.y - x, &pnt.color, fr);
		put_pixel_to_image(pnt.x + x, pnt.y - y, &pnt.color, fr);
		if (err <= 0)
		{
			y += 1;
			err += 2*y + 1;
		}
		if (err > 0)
		{
			x -= 1;
			err -= 2*x + 1;
		}
	}
}

void	recursive_circles(t_pnt pnt, float radius, t_fractol *fr)
{
	int tmp;
	drawcircle(pnt, radius, fr);
	pnt.color = color_lerp(pnt.color, color_lerp(pnt.color, color_init(0, 97, 255), 0.4), 0.3);
	if (radius > 2)
	{
		tmp = pnt.x;
		pnt.x = tmp + (int)radius / 2;
		recursive_circles(pnt, radius / 2, fr);
		pnt.x = tmp - (int)radius / 2;
		recursive_circles(pnt, radius / 2, fr);
		tmp = pnt.y;
		pnt.y = tmp + (int)radius / 2;
		recursive_circles(pnt, radius / 2, fr);
		pnt.y = tmp - (int)radius / 2;
		recursive_circles(pnt, radius / 2, fr);
	}
}

int		main(int argc, char **argv)
{
	t_fractol	*fr;
	t_pnt		pnt;
//	int 		i;

	srand(time(NULL));
	fr = NULL;
	argc = argc;
	argv = argv;
	fr = fractol_init();
//	while (pnt.y < fr->w_height)
//	{
//		pnt.x = 0;
//		pnt.color = color_lerp(int_to_color(COLOR2), int_to_color(COLOR1), (float)pnt.y / (float)fr->w_height);
//		while (pnt.x < fr->w_width)
//		{
//			drawcircle(pnt, 100, fr);
//			pnt.x += 30;
//		}
//		pnt.y += 30;
//	}
	pnt.y = fr->w_height / 2;
	pnt.x = fr->w_width / 2;
//	i = 0;
	pnt.color = color_init(255, 0, 0);
	recursive_circles(pnt, 1000, fr);
//	while (i < 10000)
//	{
//		usleep(150000);
//		recursive_circles(pnt, i, fr);
//		mlx_put_image_to_window(fr->mw->mlx, fr->mw->win, fr->image, 0, 0);
//		mlx_destroy_image(fr->mw->mlx, fr->image);
//		fr->image = mlx_new_image(fr->mw->mlx, WIDTH, HEIGHT);
//		fr->image_data = mlx_get_data_addr(
//				fr->image,
//				&fr->bpp,
//				&fr->line_size,
//				&fr->endian);
//		i +=10;
//	}
	mlx_put_image_to_window(fr->mw->mlx, fr->mw->win, fr->image, 0, 0);
	mlx_hook(fr->mw->win, 2, 5, key_hook, fr);
	mlx_loop(fr->mw->mlx);
	return (0);
}
